/* 
   $Id: sgaddr.h,v 1.5 2001/12/25 10:43:55 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgaddr.

   sgaddr is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgaddr is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgaddr; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef _SGADDR_H
#define _SGADDR_H

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#define ENABLE_NLS 1
#include <gnome.h>

#include <sys/stat.h>

#include "sg_aplaunch.h"

#define MAX_PERSONS	65536

#define MAX_CATEGORY	16
#define MAX_CATEGORY_LENGTH	20

#define ADDR_NAME    1
#define ADDR_RUBY    2
#define ADDR_HOME    3
#define ADDR_PHONE   4
#define ADDR_MOBILE  5
#define ADDR_EMAIL   6
#define ADDR_ETC     7
#define ADDR_CATEGORY     8

#define BTN_ADD     0
#define BTN_DEL     1
#define BTN_REEDIT  2
#define BTN_PREV    3
#define BTN_NEXT    4
#define BTN_APPLY   5
#define BTN_NEW     6
#define BTN_QUIT    7
#define BTN_RETURN  8

#define STATE_EDITING    (1 << 0)
#define STATE_NEWENTRY   (1 << 1)
#define STATE_REEDIT     (1 << 2)

struct  person_data{
  char *name;
  char *ruby;
  char *home;
  char *phone;
  char *mobile;
  char *email;
  char *etc;
  char *category;	/* 02-08-10 Add */
};

void button_press(GtkWidget *widget, gpointer data);
void sgaddr_main_button_press(GtkWidget *widget, gpointer data);
void sgaddr_return_button(GtkWidget *widget, gpointer data);
void sgaddr_buttons_switch();

void set_entry_editable(int boolean);

void sort_by_ruby();
int sgaddr_locale_ja_chk(char *locale);

void save_category_data();
void load_category_data();

void set_person_data_to_entry(struct person_data *data);
void set_person_data_all(GtkCList *clist);
void save_person_data();
void load_person_data();
struct person_data *create_person_data();
void insert_person_data(struct person_data *data);
void remove_person_data(int num);
int get_edit_state();	/* return status */
void set_edit_state(int state);
struct person_data *get_person_data(int num);

void set_string_to_entry(GtkWidget *widget, char *str);
char *get_string_from_entry(GtkWidget *widget, char *dest);

void select_category_menu();

void press_new_btn();
void press_add_btn();
void press_del_btn();
void press_reedit_btn();
void press_apply_btn();

void cut_text();
void copy_text();
void paste_text();
void selall_text();

#endif
