/* 
   $Id: sgaddr_btn.c,v 1.4 2001/12/25 10:43:56 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgaddr.

   sgaddr is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgaddr is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgaddr; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <X11/X.h>
#include <gdk/gdkx.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>

#ifdef NOVCARD

#include "sgaddr.h"

#else

#include "sgaddr.h"
#include "sgvcard.h"

#endif


extern GtkWidget  *main_container_table;
extern GtkWidget  *main_container_list;
extern GtkWidget  *main_container_detail;

extern GtkWidget  *notebook;
extern GtkWidget  *name_entry, *ruby_entry, *home_entry;
extern GtkWidget  *phone_entry, *mobile_entry, *email_entry, *etc_entry;
extern GtkWidget  *list;
extern GtkWidget  *main_text;
extern int        array_tail, current_num;
extern int        array_tail_cate, current_cate_num;

extern struct person_data *array[MAX_PERSONS];
extern char *c_array[MAX_CATEGORY];

int  current_state = STATE_REEDIT;
extern int current_row;

/*
** ե˥塼饫ƥԽ¹Ԥ
*/
void select_category_menu()
{
  system( "sgcate &" );
}


/*
** ܤ
*/
void sgaddr_nunome_popup( int mode )
{
    XClientMessageEvent ev;
    Atom atom;
	Display *dpy;

	dpy = XOpenDisplay(NULL);

	if( mode == TRUE ){
		atom = XInternAtom( dpy, "_AXE_SGWM_MAP_NUNOME", False );
	}else{
		atom = XInternAtom( dpy, "_AXE_SGWM_UNMAP_NUNOME", False );
	}

	ev.type = ClientMessage;
	ev.window = DefaultRootWindow(dpy);
	ev.message_type = atom;
	ev.format = 32;

	XSendEvent( dpy, DefaultRootWindow(dpy), False,
				SubstructureNotifyMask, (XEvent *)&ev );

    XSync( dpy, False );
}


/*
** ƥΰԽ⡼
*/
int get_edit_state()
{
  return( current_state );
}


/*
** ơREEDITΤȤϻȤΤ߲ǽEDITINGNEWENTRYԽǽ
** EDITING|NEWENTRYѹEDITING
*/
void set_edit_state(int state)
{
  current_state = state;

  sgaddr_buttons_switch();

  if( state & STATE_EDITING ){
    sgaddr_nunome_popup( TRUE );

  }else{
    sgaddr_nunome_popup( FALSE );

  }

}

/*
** ƥ̵꤬翷˳դ롣Ʊʤ餽Τޤޡ
** c_array[] : ƥơ֥
** array_tail_cate : ƥϿ
** ƥƬALLʤΤǡڡΥǥåۤʤ
*/
char *get_category( char *data )
{
  int page;
  char *w_category;

  page = gtk_notebook_get_current_page( GTK_NOTEBOOK(notebook) );

  if( page <= 0 ){
    if( data != NULL ){
      free( data );
    }
    w_category = strdup( "" );

  }else{

    if( array_tail_cate < page ){
      if( data != NULL ){
        free( data );
      }
      w_category = strdup( "" );

    }else{

      if( data != NULL ){
        if( strcmp( data, c_array[page-1] ) != 0 ){
          free( data );
          w_category = strdup( c_array[page-1] );
        }else{
          w_category = data;
        }
      }else{
        w_category = strdup( c_array[page-1] );
      }

    }
  }

  return( w_category );

}


/*
** ɲåܥ
*/
void press_add_btn()
{
  int status;
  struct person_data *tmp = NULL;

  tmp = (struct person_data *) malloc(sizeof(struct person_data));
  bzero(tmp, sizeof(struct person_data));

  tmp->name   = get_string_from_entry(name_entry, tmp->name);
  tmp->ruby   = get_string_from_entry(ruby_entry, tmp->ruby);
  tmp->home   = get_string_from_entry(home_entry, tmp->home);
  tmp->phone  = get_string_from_entry(phone_entry, tmp->phone);
  tmp->mobile = get_string_from_entry(mobile_entry, tmp->mobile);
  tmp->email  = get_string_from_entry(email_entry, tmp->email);
  tmp->etc    = get_string_from_entry(etc_entry, tmp->etc);
  tmp->category = get_category( tmp->category );

  set_entry_editable(FALSE);

  if(!(current_state & STATE_EDITING))  
    gtk_text_set_editable(GTK_TEXT(main_text), FALSE);

  /*
  ** ơ֥ɲ
  */
  if( current_num < 0 ){

    insert_person_data(tmp);

    /*
    ** ɲåǡȿǤƺƥ
    */
    sort_by_ruby();

  }else{

    free_person_data( current_num );

    array[current_num] = tmp;

  }

  /*
  ** ơ֥򹹿
  */
#ifdef NOVCARD
  status = 0;
  save_person_data();
#else
  status = sgWriteVCard();
  if( status != 0 ){
  	quit( NULL, NULL );
  }
#endif

  /*
  ** ꥹȥܥåɽ
  */
  set_person_data_all(GTK_CLIST(list));
  set_edit_state(STATE_REEDIT);

  if( current_row >= 0 ){
    gtk_clist_unselect_row( GTK_CLIST(list), current_row, -1 );
  }

  current_row = -1;
  current_num = -1;

  gtk_widget_hide( main_container_detail );
  gtk_widget_show( main_container_list );

  gtk_widget_set_sensitive( notebook, TRUE );

}

/*
** ܥ
*/
void close_dialog(GtkWidget *widget, gpointer data)
{
  gtk_grab_remove(widget);
}

void
message_btn(char *message, void (*y_func)(), void (*n_func)())
{
  GtkWidget *dialog;
  GtkWidget *d_mesg;
  GtkWidget *y_btn, *n_btn;

  dialog = gtk_dialog_new();

  gtk_signal_connect(GTK_OBJECT(dialog), "destroy",
		     GTK_SIGNAL_FUNC(close_dialog), NULL);

  gtk_window_set_title(GTK_WINDOW(dialog), NULL);

  d_mesg = gtk_label_new(message);

  gtk_misc_set_padding(GTK_MISC(d_mesg), 10, 10);

  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),
		     d_mesg, TRUE, TRUE, 0);

  y_btn = gtk_button_new_with_label(_("Yes"));
  n_btn = gtk_button_new_with_label(_("No"));

  gtk_signal_connect(GTK_OBJECT(y_btn), "clicked",
		     GTK_SIGNAL_FUNC(y_func), dialog);
  gtk_signal_connect(GTK_OBJECT(n_btn), "clicked",
		     GTK_SIGNAL_FUNC(n_func), dialog);

  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
		     y_btn, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
		     n_btn, TRUE, TRUE, 0);

  gtk_widget_show(d_mesg);
  gtk_widget_show(y_btn);
  gtk_widget_show(n_btn);
  gtk_widget_show(dialog);
  gtk_grab_add(dialog);
}

void yes_delete(GtkWidget *widget, gpointer data)
{
  if(array_tail < 1) return;

  remove_person_data(current_num);

  sort_by_ruby();
  set_person_data_all(GTK_CLIST(list));

  /**
  if(array_tail > 0)
    set_person_data_to_entry(get_person_data(current_num));    
	**/

  if(!(current_state & STATE_EDITING))  
    gtk_text_set_editable(GTK_TEXT(main_text), FALSE);
  set_entry_editable(FALSE);

  set_edit_state(STATE_REEDIT);
  gtk_widget_destroy(GTK_WIDGET(data));

  gtk_widget_hide( main_container_detail );
  gtk_widget_show( main_container_list );

  gtk_clist_unselect_row( GTK_CLIST(list), current_row, -1 );
  current_row = -1;
  current_num = -1;

  gtk_widget_set_sensitive( notebook, TRUE );
}

void no_delete(GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(GTK_WIDGET(data));
}

void press_del_btn()
{
  message_btn(_("Do you want to delete?"), yes_delete, no_delete);
}

/*
** ѹܥ
*/
void press_reedit_btn()
{
  if( current_num < 0 ){
    return;
  }

  set_entry_editable(TRUE);
  set_edit_state(STATE_REEDIT | STATE_EDITING);

  gtk_widget_set_sensitive( notebook, TRUE );
}

/*
** ܥ
*/
void press_new_btn()
{
  set_entry_editable(TRUE);
  set_string_to_entry(name_entry, NULL);
  set_string_to_entry(ruby_entry, NULL);
  set_string_to_entry(home_entry, NULL);
  set_string_to_entry(phone_entry, NULL);
  set_string_to_entry(mobile_entry, NULL);
  set_string_to_entry(email_entry, NULL);
  set_string_to_entry(etc_entry, NULL);
  set_edit_state(STATE_NEWENTRY | STATE_EDITING);

  gtk_widget_show( main_container_detail );
  gtk_widget_hide( main_container_list );

  gtk_widget_set_sensitive( notebook, TRUE );
}

/*
** ܥ󡢼åܥ
*/
void
press_return_btn()
{
  if(!(current_state & STATE_EDITING))  
    gtk_text_set_editable(GTK_TEXT(main_text), FALSE);

  set_entry_editable(FALSE);
  set_edit_state(STATE_REEDIT);

  gtk_clist_unselect_row( GTK_CLIST(list), current_row, -1 );

  current_row = -1;
  current_num = -1;

  gtk_widget_hide( main_container_detail );
  gtk_widget_show( main_container_list );

  gtk_widget_set_sensitive( notebook, TRUE );
}

/*
** ܥ򲡤ȼꤢ
*/
void button_press(GtkWidget *widget, gpointer data)
{
  switch((int)data){
  case BTN_REEDIT:  press_reedit_btn();   break;
  case BTN_NEW:     press_new_btn();      break;
  case BTN_ADD:     press_add_btn();      break;
  case BTN_DEL:     press_del_btn();      break;
  case BTN_RETURN:  press_return_btn();   break;
  }
}

