/* 
   $Id: sgaddr_category_list.c,v 1.0 2002/08/22 10:43:56 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgaddr.

   sgaddr is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgaddr is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgaddr; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "sgaddr.h"

extern  int                array_tail_cate, current_cate_num;
extern  char 		   *c_array[MAX_CATEGORY]; 

char *
create_category_data( const char *data )
{
  char *tmp = NULL;
  int len=strlen(data);

  tmp = (char *) calloc(1, len+1 );
  if(tmp != NULL) return tmp;

  return NULL;
}

void
insert_category_data(char *data)
{
  int i;
  int len;
  char *tmp;
  const char *p;

  while( *data ){
    if( strchr( " \t", *data ) == NULL ){
      break;
    }

    data++;
  }

  p = data;
  for( i=0; i<array_tail_cate; i++ ){
    if( strcmp( p, c_array[i] ) == 0
    ||  strlen( p ) > MAX_CATEGORY_LENGTH ){
      return;
    }
  }

  tmp = create_category_data( p );
  if( tmp == (char*)NULL ){
    return;
  }

  if( strlen(data) > MAX_CATEGORY_LENGTH ){
    len = MAX_CATEGORY_LENGTH;
  }else{
    len = strlen(data);
  }

  sprintf( tmp, "%*.*s", len, len, data );

  c_array[array_tail_cate++] = tmp;
}

/******/
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

char *initCategoryList[] = {
  "Private",
  "Business",
};

static void set_sgcategory_file (){
  struct stat sb;
  char buff[64];
  FILE *fd;
  int i = 0;

  sprintf (buff, "%s/sgcategory", getenv ("HOME"));

  if (stat (buff, &sb) < 0)
    {
      if ((fd = fopen (buff, "w")) != NULL)
	{
	  /**
	   ** $BK\Ev$O0J2<$N$h$&$K!"(Bwhile$B$G=hM}$9$Y$-$@$,!"(B
	   ** vcc.c$B$,Ff$NJ8;zNs(B"BOX EXT ADD STREET L R PC C"$B$rDI2C$7$F$7$^$&$N$G!"(B
	   ** for $B$GF($2$k$3$H$K$9$k!#(B
	  while (initCategoryList[i] != '\0')
	    {
	      fprintf (fd, "%s\n", initCategoryList[i]);
	      i++;
	    }	  
	  **/
	  for (i = 0; i < 2; i++) 
	    fprintf (fd, "%s\n", initCategoryList[i]);

	  fclose (fd);
	}
      else
	{
	  fprintf (stderr, "Warning: can't write %s\n", buff);
	}
    }
}

/******/

void load_category_data()
{
  FILE               *fp = NULL;
  char               str[4096];
  char               *home;
  char               fn[4096];

  int  i,c;

  set_sgcategory_file ();

  if ((home = getenv("HOME")) != NULL) {
    sprintf(fn,"%s/sgcategory",home);
  } else {
    sprintf(fn,"sgcategory");
  }
  fp = fopen(fn, "r");
  
  if(fp == NULL){
    fprintf(stderr, "I can't open category file:%s.\n"
      "I will try to create one later.\n",fn);
    return;
  }

  i = 0;
  while( 1 ){
    memset( str, '\0', sizeof(str) );
    fgets( str, sizeof(str)-1, fp );
    if( feof(fp) ){
      break;
    }

    c = strlen(str);
    if( c > 0 && str[c-1] == '\n' ){
      str[c-1] = '\0';
    }

    if( array_tail_cate >= MAX_CATEGORY ){
      break;
    }

    insert_category_data( str );

  }

  fclose(fp);
}

