/* 
   $Id: sgaddr_main.c,v 1.8 2001/12/25 10:43:56 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgaddr.

   sgaddr is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgaddr is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgaddr; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <X11/X.h>

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>

#ifdef NOVCARD

#include "sgaddr.h"

#else

#include "sgaddr.h"
#include "sgvcard.h"

#endif

#include "config.h"

GtkWidget *app;

/*
** ᥤ󥦥ɥĥĤƤȥåפΥƥ
*/
GtkWidget  *main_container_vbox;
GtkWidget  *main_container_list;   /*  */
GtkWidget  *main_container_detail; /* ܺ */

/*
** ̤˴ؤ륦åȤ
*/
GtkWidget  *notebook;
GtkWidget  *list_table;
GtkWidget  *list;
  
GtkWidget  *kana_table;
GtkWidget  *button_table;

/*
** ܺٲ̤˴ؤ륦åȤ
*/
GtkWidget  *name_entry, *ruby_entry, *home_entry;
GtkWidget  *phone_entry, *mobile_entry, *email_entry, *etc_entry;

GtkWidget  *main_note_buttons_table;
GtkWidget  *main_note_buttons_view;  /* state="VIEW" */
GtkWidget  *main_note_buttons_edit;  /* state="EDIT" */

/*
** ̾ɸϤʤå&ڡ˻ѤХåե
*/
GtkWidget  *main_text;

GtkWidget  *selection_src = NULL;

int    array_tail = 0, current_num = -1;
struct person_data *array[MAX_PERSONS]; 
int    array_tail_cate = 0;
char *c_array[MAX_CATEGORY];

int current_page;
int current_row=-1;

int kana_array[12]; 

static GnomeUIInfo main_menu[] = {

  {
    GNOME_APP_UI_ITEM,
    N_("CATEGORY"), NULL,
    GTK_SIGNAL_FUNC(select_category_menu), NULL, NULL,
    GNOME_APP_PIXMAP_NONE , NULL,
    0, GDK_CONTROL_MASK, NULL
  },

  {
    GNOME_APP_UI_ITEM,
    N_("Quit"), NULL,
    GTK_SIGNAL_FUNC(gtk_main_quit), NULL, NULL,
    GNOME_APP_PIXMAP_STOCK , GNOME_STOCK_MENU_QUIT,
    0, GDK_CONTROL_MASK, NULL
  },

  GNOMEUIINFO_END
};

/*
** å
*/
void cut_text()
{
  if(selection_src != NULL)
    gtk_editable_cut_clipboard(GTK_EDITABLE(selection_src));
}

/*
** ԡ
*/
void copy_text()
{
  if(selection_src != NULL){
    gtk_editable_copy_clipboard(GTK_EDITABLE(selection_src));
    gtk_editable_select_region(GTK_EDITABLE(selection_src), 0, 0);
  }
}

/*
** ڡ
*/
void paste_text()
{
  if(selection_src != NULL)
    gtk_editable_paste_clipboard(GTK_EDITABLE(selection_src));
}

/*
** 
*/
void selall_text()
{
  if(selection_src != NULL)
    gtk_editable_select_region(GTK_EDITABLE(selection_src), 0, -1);
}

void set_selection_src_widget(GtkWidget *widget, GdkEventFocus *ev)
{
  selection_src = widget;
}

void unset_selection_src_widget(GtkWidget *widget, GdkEventFocus *ev)
{
  selection_src = NULL;
}


/*
** 1ʬΥɥ쥹ǡclistɲ
** ΤȤʤ(Ĥ)ˡֹ̤ǤΥǥå򱣤Ƥ
** select_row줿ȤˡºݤΥơ֥֤ǼǤ
** Ȥ줿ȡ̤ɽ˺֤ʤ
*/
void set_person_data_to_clist(GtkCList *clist, struct person_data *data, int idx )
{
  char *strs[16];
  static char buf[6];

  if(!data) return;

  strs[0] = data->name;
  strs[1] = data->ruby;
  sprintf( buf, "%d", idx );
  strs[2] = buf;
  strs[3] = NULL;

  gtk_clist_append(clist, strs);
}


/*
** ꥹȥܥåإǡ
** ƥʬɽǡ
** ǥåǡֹ̤
*/
void
set_person_data_all(GtkCList *clist)
{
  int i;
  struct person_data *data;

  gtk_clist_clear(clist);

  for(i = 0; i < array_tail; i++){

    if( current_page == 0 ){
      set_person_data_to_clist(clist, get_person_data(i), i);
    }else{
      data = get_person_data(i);
      if( strcmp( data->category, c_array[current_page-1] ) == 0 ){
        set_person_data_to_clist(clist, get_person_data(i), i);
      }
    }
  }
}

/*
** ܺٲΥȥԽ/ԲĤڤؤ
*/
void set_entry_editable(int boolean)
{
  gtk_entry_set_editable(GTK_ENTRY(name_entry),   boolean);
  gtk_entry_set_editable(GTK_ENTRY(ruby_entry),   boolean);
  gtk_entry_set_editable(GTK_ENTRY(home_entry),   boolean);
  gtk_entry_set_editable(GTK_ENTRY(phone_entry),  boolean);
  gtk_entry_set_editable(GTK_ENTRY(mobile_entry), boolean);
  gtk_entry_set_editable(GTK_ENTRY(email_entry),  boolean);
  gtk_entry_set_editable(GTK_ENTRY(etc_entry),    boolean);
  gtk_text_set_editable(GTK_TEXT(main_text), boolean);
}

/*
** Ѥʥܥ
*/
void kana_button_press(GtkWidget *widget, gpointer data)
{
  int i = (int)data;
  int j, row;

  if(kana_array[i] >= 0){

    row = -1;

	if( current_page == 0 ){
		row = kana_array[i];
	}else{
		for( j=kana_array[i]; j<array_tail; j++ ){
			if( array[j]
			&&  array[j]->category
			&&  strcmp( array[j]->category, c_array[current_page] ) == 0 ){
				row = j;
			}
		}
	}

	if( row >= 0 ){
		gtk_clist_moveto (GTK_CLIST(list), row, 0, 0.0, 0.0);
  	}

  }
}

/*
** ȥؤΥǡѥ֥롼
*/
void set_string_to_entry(GtkWidget *widget, char *str)
{
  if(str) gtk_entry_set_text(GTK_ENTRY(widget), str);
  else    gtk_editable_delete_text(GTK_EDITABLE(widget), 0, -1);
}

/*
** ȥ꤫Υǡѥ֥롼
*/
char *
get_string_from_entry(GtkWidget *widget, char *dest)
{
  char *str = NULL;

  str = gtk_entry_get_text(GTK_ENTRY(widget));

  if(str && (strlen(str) > 0)){
    if(dest){
      if(strcmp(str, dest) != 0){
	free(dest);
	dest = (char *)strdup(str);
      }
    }else{
      dest = (char *)strdup(str);
    }
  }else{
    if(dest) free(dest);
    dest = NULL;
  }

  return dest;
}

/*
** ơ֥뤫ܺٲ̤ؤΥǡԤ
*/
void
set_person_data_to_entry(struct person_data *data)
{
  set_string_to_entry(name_entry,   data->name);
  set_string_to_entry(ruby_entry,   data->ruby);
  set_string_to_entry(home_entry,   data->home);
  set_string_to_entry(phone_entry,  data->phone);
  set_string_to_entry(mobile_entry, data->mobile);
  set_string_to_entry(email_entry,  data->email);
  set_string_to_entry(etc_entry,    data->etc);
}

/*
** ɥ쥹ǡ
** 쥯Ȥ˾ܺٲ̤ذܤ롣ޤԽϤǤʤ
*/
void 
select_row(GtkWidget *list, gint row, gint column, GdkEvent *event, gpointer data)
{
  char *text;
  int seq_no;
/*
**
*/
  if( array_tail <= 0 ){
  	return;
  }

  current_row = row;

  gtk_clist_get_text( GTK_CLIST(list), row, 2, &text );

  seq_no = atoi(text);

  set_person_data_to_entry(get_person_data(seq_no));
  current_num = seq_no;

  set_edit_state(STATE_REEDIT);

  gtk_widget_set_sensitive( notebook, FALSE );

  gtk_widget_hide( main_container_list );
  gtk_widget_show( main_container_detail );
}

/*
** ܥ򲡤줿Ȥʤɤˡ֤᤹˻
*/
void 
unselect_row(GtkWidget *list, gint row, gint column, GdkEvent *event, gpointer data)
{
  current_row = -1;
  current_num = -1;
}

/*
** λܥ
*/
void quit(GtkWidget *widget, gpointer data)
{
  int status;

  gtk_main_quit();

#ifdef NOVCARD
  status = 0;
  save_person_data();
#else
  status = sgWriteVCard();
  if( status != 0 ){
  	return;
  }
#endif

}

void quit_ev(GtkWidget *widget, GdkEvent *event, gpointer data)
{
	quit(widget, data);
}

void key_press(GtkWidget *widget, GdkEventKey *event, gpointer data)
{
  switch(event->keyval){
  case GDK_Return:
  case GDK_Tab:
    break;

  default:
    break;
  }
}


/*
** ƥڤؤ(clistκ)
*/
void switch_page(GtkNotebook *notebook, GtkNotebookPage *page, guint page_num)
{

  current_page = page_num;

  /*
  ** list
  */
  sort_by_ruby();
  set_person_data_all( GTK_CLIST(list) );
}


/*
** ܺٲ̥ȥΰ֥롼
*/
GtkWidget *
create_entry(GtkWidget *table, char *str, int num, int x, int y)
{
  GtkWidget *label, *entry;

  label = gtk_label_new(str);
  entry = gtk_entry_new();

  gtk_table_attach(GTK_TABLE(table), label, x, x + 1, y, y + 1,
		   GTK_FILL|GTK_EXPAND, GTK_SHRINK, 0, 0);

  gtk_table_attach(GTK_TABLE(table), entry, x + 1, x + 2, y, y + 1,
		   GTK_FILL|GTK_EXPAND, GTK_SHRINK, 0, 0);

  gtk_signal_connect(GTK_OBJECT(entry), "key_press_event",
		     GTK_SIGNAL_FUNC(key_press), (gpointer) num);

  gtk_signal_connect(GTK_OBJECT(entry), "focus_in_event",
		     GTK_SIGNAL_FUNC(set_selection_src_widget), 
		     0);
  gtk_signal_connect(GTK_OBJECT(entry), "focus_out_event",
		     GTK_SIGNAL_FUNC(unset_selection_src_widget), 
		     0);
  
  gtk_widget_show(label);
  gtk_widget_show(entry);

  return entry;
}

/*
** ̥ܥΰ֥롼
*/
GtkWidget *
create_button(GtkWidget *container, char *label, GtkSignalFunc func, int num, int x, int y)
{
  GtkWidget *btn;

  btn = gtk_button_new_with_label(label);
  gtk_signal_connect(GTK_OBJECT(btn), "clicked",
		     GTK_SIGNAL_FUNC(func), (gpointer)num);

  gtk_table_attach(GTK_TABLE(container), btn,
		   x, x + 1, y, y + 1,
		   GTK_FILL|GTK_EXPAND|GTK_SHRINK, GTK_SHRINK, 0, 0);
  
  gtk_widget_show(btn);

  return btn;
}



int sgaddr_locale_ja_chk(char *locale)
{
#ifdef __FreeBSD__
    return strcmp(locale, "ja_JP.EUC") == 0;
#else
    return strncmp(locale, "ja", 2) == 0;
#endif
}


/*
** ̥֥ȥκ
*/
void
create_category_tab()
{
  int i;
  GtkWidget *label;
  GtkWidget *dummy;

  notebook = gtk_notebook_new();
  gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_TOP);
  gtk_notebook_set_scrollable( GTK_NOTEBOOK(notebook), TRUE );

  for( i=0; i<=array_tail_cate; i++ ){

    if( i==0 ){
      label = gtk_label_new( _("All") );
    }else{
      label = gtk_label_new( c_array[i-1] );
    }
    dummy = gtk_fixed_new();
    gtk_widget_show( label );
    gtk_widget_show( dummy );
    gtk_notebook_append_page( GTK_NOTEBOOK(notebook), dummy, label );

  }

  gtk_widget_show( notebook );

  gtk_signal_connect (GTK_OBJECT (notebook), "switch_page",
		      GTK_SIGNAL_FUNC (switch_page), NULL);

}

/*
** ̤κ
*/
static void sgaddr_create_list_page()
{
  GtkWidget *list_table;
  GtkWidget *vscroll;
  GtkObject *adjustment;
  
  GtkWidget *kana_table;
  GtkWidget *button_table;

  char *list_titles[3];
  char *locale;

  main_container_list = gtk_vbox_new( FALSE, 0 );

  gtk_box_pack_start( GTK_BOX(main_container_vbox),
		      main_container_list, TRUE, TRUE, 0 );


  /*
  ** ꥹʬκ
  */
  list_titles[0] = _("Name");
  list_titles[1] = _("Ruby");
  list_titles[2] = _("debug seq.");

  list_table = gtk_table_new(1, 2, FALSE);
  
  list = gtk_clist_new_with_titles(3, list_titles);
  gtk_signal_connect (GTK_OBJECT (list), "select_row", 
		      GTK_SIGNAL_FUNC (select_row), NULL);
  gtk_signal_connect (GTK_OBJECT (list), "unselect_row", 
		      GTK_SIGNAL_FUNC (unselect_row), NULL);

  gtk_clist_column_titles_passive(GTK_CLIST(list));
  gtk_clist_set_column_width(GTK_CLIST(list), 0, 80);
  gtk_clist_set_column_width(GTK_CLIST(list), 1, 80);
  gtk_clist_set_column_width(GTK_CLIST(list), 2, 5);
  gtk_widget_set_usize(list, 1, 1);

  /*
  ** array_tail ȤδϢդɽΥ˻
  */
/*
  gtk_clist_set_column_visibility( GTK_CLIST(list), 2, TRUE );
*/
  gtk_clist_set_column_visibility( GTK_CLIST(list), 2, FALSE );

  adjustment = gtk_adjustment_new (0.0, 0.0, 1000000.0, 1.0, 25.0, 25.0);
  gtk_clist_set_vadjustment(GTK_CLIST(list), GTK_ADJUSTMENT(adjustment));
  vscroll = gtk_vscrollbar_new(GTK_ADJUSTMENT(adjustment));

  /*
  ** ѤΤʻܥʬκ
  */
  kana_table = gtk_table_new(2, 6, FALSE);

  create_button(kana_table, _("ABC"),  kana_button_press,  0, 0, 0);
  create_button(kana_table, _("DEF"),  kana_button_press,  1, 1, 0);
  create_button(kana_table, _("GHI"),  kana_button_press,  2, 2, 0);
  create_button(kana_table, _("JKL"),  kana_button_press,  3, 3, 0);
  create_button(kana_table, _("MNO"),  kana_button_press,  4, 4, 0);
  create_button(kana_table, _("PQRS"), kana_button_press,  5, 5, 0);
  create_button(kana_table, _("TUV"),  kana_button_press,  6, 0, 1);
  create_button(kana_table, _("WXYZ"), kana_button_press,  7, 1, 1);

  locale = getenv("LC_MESSAGES");
  if(locale == NULL) locale = getenv("LANG");

  if(locale){
    if(sgaddr_locale_ja_chk(locale)){
      create_button(kana_table, _("RA"),   kana_button_press,  8, 2, 1);
      create_button(kana_table, _("WA"),   kana_button_press,  9, 3, 1);
      create_button(kana_table, _("Alpha"),kana_button_press, 10, 4, 1);
    }
  }

  create_button(kana_table, _("Num"), kana_button_press, 11, 5, 1);

  /*
  **
  */
  button_table = gtk_table_new(1, 3, TRUE);
  create_button(button_table, _("New"), press_new_btn, 0, 0, 0);

  gtk_table_attach(GTK_TABLE(list_table), list, 0, 1, 0, 1,
		   GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 0, 0);
  
  gtk_table_attach(GTK_TABLE(list_table), vscroll, 1, 2, 0, 1,
		   GTK_SHRINK, GTK_FILL|GTK_EXPAND, 0, 0);

  gtk_table_attach(GTK_TABLE(list_table), kana_table, 0, 1, 1, 2,
		   GTK_FILL|GTK_EXPAND, GTK_SHRINK, 0, 0);  

  gtk_table_attach(GTK_TABLE(list_table), button_table, 0, 1, 2, 3,
		   GTK_FILL|GTK_EXPAND|GTK_SHRINK, GTK_SHRINK, 0, 2);  

  gtk_box_pack_start( GTK_BOX(main_container_list),
		      list_table,
		      TRUE, TRUE, 0 );

  gtk_widget_show(button_table);
  gtk_widget_show(kana_table);
  gtk_widget_show(list);
  gtk_widget_show(vscroll);
  gtk_widget_show(list_table);
  gtk_widget_show(main_container_list);

}

/*
** ܺٲΥܥΡ󥷥ƥڤؤѥ֥롼
*/
void sgaddr_buttons_switch()
{
  int state;

  state = get_edit_state();

  if( state != STATE_REEDIT ){
    gtk_widget_show( main_note_buttons_edit );
    gtk_widget_hide( main_note_buttons_view );
  }else{
    gtk_widget_show( main_note_buttons_view );
    gtk_widget_hide( main_note_buttons_edit );
  }
}



/*
** ܺٲ̤κ
*/
static void sgaddr_create_main_page()
{
  GtkWidget *detail_table;
  GtkWidget *main_text_table;
  GtkWidget *sw;	/* 륦ɥѥå */

  main_container_detail = gtk_vbox_new( FALSE, 0 );

  gtk_box_pack_start( GTK_BOX(main_container_vbox),
		      main_container_detail, TRUE, TRUE, 0 );

  /*
  ** ᥤΥƥʤδ֤˥륦ɥ
  */
  sw = gtk_scrolled_window_new( NULL, NULL );

  gtk_box_pack_start( GTK_BOX(main_container_detail),
		      sw, TRUE, TRUE, 0 );

  gtk_scrolled_window_set_policy( GTK_SCROLLED_WINDOW(sw),
				  GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC );



  /* to make entry widgets  */

  /*
  ** ܥѥơ֥
  */
  detail_table = gtk_table_new(7, 2, FALSE);

  name_entry   = create_entry(detail_table, _("Name"),   ADDR_NAME,   0, 0);
  ruby_entry   = create_entry(detail_table, _("Ruby"),   ADDR_RUBY,   0, 1);
  home_entry   = create_entry(detail_table, _("Home"),   ADDR_HOME,   0, 2);
  phone_entry  = create_entry(detail_table, _("Phone"),  ADDR_PHONE,  0, 3);
  mobile_entry = create_entry(detail_table, _("Mobile"), ADDR_MOBILE, 0, 4);
  email_entry  = create_entry(detail_table, _("E-mail"), ADDR_EMAIL,  0, 5);
  etc_entry    = create_entry(detail_table, _("Etc"),    ADDR_ETC,    0, 6);
  
  gtk_widget_show(detail_table);

  /*
  ** "VIEW" StateΥܥ
  */
  main_note_buttons_view =  gtk_table_new(1, 3, TRUE);

  create_button(main_note_buttons_view,
		_("Reedit"), button_press, BTN_REEDIT, 0, 0);
  create_button(main_note_buttons_view,
		_("Del"),    button_press, BTN_DEL,    1, 0);
  create_button(main_note_buttons_view,
		_("Return"), button_press, BTN_RETURN, 2, 0);

  gtk_widget_show( main_note_buttons_view );


  /*
  ** "EDIT" StateΥܥ
  */
  main_note_buttons_edit =  gtk_table_new(1, 3, TRUE);

  create_button(main_note_buttons_edit,
		_("Add"),    button_press, BTN_ADD, 0, 0);
  create_button(main_note_buttons_edit,
		_("Cancel"), button_press, BTN_RETURN, 1, 0);

  gtk_widget_show( main_note_buttons_edit );

  /* to make a text widget  */
  main_text_table = gtk_table_new(2, 2, FALSE);
  main_text  = gtk_text_new(NULL, NULL);  

  gtk_table_attach(GTK_TABLE(main_text_table), main_text, 0, 1, 0, 1,
		   GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 0, 0);
  gtk_widget_show(main_text);

  gtk_signal_connect(GTK_OBJECT(main_text), "focus_in_event",
		     GTK_SIGNAL_FUNC(set_selection_src_widget), 
		     0);

  gtk_signal_connect(GTK_OBJECT(main_text), "focus_out_event",
		     GTK_SIGNAL_FUNC(unset_selection_src_widget), 
		     0);


  gtk_scrolled_window_add_with_viewport( GTK_SCROLLED_WINDOW(sw), detail_table );


  gtk_box_pack_start( GTK_BOX(main_container_detail),
		      main_note_buttons_view, FALSE, FALSE, 0 );

  gtk_box_pack_start( GTK_BOX(main_container_detail),
		      main_note_buttons_edit, FALSE, FALSE, 0 );

  gtk_widget_show_all( main_container_detail );

}




/*
** ɥ쥹Ģᥤ󥦥ɥκ
*/
void
create_main_window()
{

  /*
  ** ֤ǥᥤΥƥʤϻʤ
  */
  create_category_tab();

  gtk_box_pack_start( GTK_BOX(main_container_vbox),
		      notebook, FALSE, FALSE, 0 );

  sgaddr_create_list_page();
  sgaddr_create_main_page();

  /* ̤ɽơܺٲ̤ϱ */
  gtk_widget_show( main_container_list );
  gtk_widget_hide( main_container_detail );

}


int main(int argc, char **argv)
{
  int status;

  status = SGCheckDinvoke(argv[0]);
  if(status > 0) return -1;

  bindtextdomain(PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain(PACKAGE);

  gtk_set_locale();

  gnome_init (PACKAGE, VERSION, argc, argv);
  app = gnome_app_new(PACKAGE, _("sgaddr"));

  gtk_signal_connect (GTK_OBJECT (app), "delete_event",
		      GTK_SIGNAL_FUNC (quit_ev), NULL);

  /*
  ** ƥɤ߹ ($HOME/sgcategory)
  */
  load_category_data();

  main_container_vbox = gtk_vbox_new(FALSE,0);
  gnome_app_set_contents(GNOME_APP(app), main_container_vbox);

  /*
  ** ƤΥåȤ
  */
  create_main_window();
  gnome_app_create_menus(GNOME_APP(app), main_menu);

  gtk_widget_show(main_container_vbox);
  gtk_widget_show(app);

  /*
  ** ɥ쥹Ģɤ߹ ($HOME/sgaddrbook)
  */
#ifdef NOVCARD
  status = 0;
  load_person_data();
#else
  status = sgReadVCard();
  if( status < 0 ){
  	exit( 0 );
  }
#endif
 

  current_page = 0;

  sort_by_ruby();
  set_person_data_all(GTK_CLIST(list));

  set_entry_editable(FALSE);

  gtk_main();

#ifdef NOVCARD
  save_person_data();
#else
  sgWriteVCard();
#endif
  return 1;
}
