/*
********************************************************************
vCard Access API for SIKIGAMI.
********************************************************************
*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>

/* #include "vcaltmp.h" */
#include "sgvcard.h"

extern void prnitValue();

VObject* sgCreateVCard(
	char *name,
	char *ruby,
	char *address,
	char *tel,
	char *mobile,
	char *mail,
	char *etc,
	char *category
	)
{
	/**
	char *date_created=NULL;
	char *location=NULL;
	char *product_id=NULL;
	char *time_zone=NULL;
	**/
	VObject *tel_home;
	VObject *tel_cell;

	VObject *vcard = newVObject(VCCardProp);

	/* Base Item Set */
	/*
	if( date_created )	addPropValue(vcard,	VCDCreatedProp,	date_created);
	if( location )		addPropValue(vcard,	VCLocationProp,	location);
	if( product_id )	addPropValue(vcard,	VCProdIdProp,	product_id);
	if( time_zone )		addPropValue(vcard,	VCTimeZoneProp,	time_zone);
	*/

	addPropValue(vcard,	VCVersionProp,	"3.0");		/* version */

	/* PIM Item Set */
	if( name )		addPropValue(vcard,	VCFullNameProp,		name );
	addPropValue(vcard,	VCNameProp,			"" );
	if( ruby )		addPropValue(vcard,	VCSortStringProp,	ruby );
	if( address )	addPropValue(vcard,	VCAdrProp,			address );
	if( tel )		tel_home = addPropValue(vcard,	VCTelephoneProp,	tel );	/* TYPE:home */
	else			tel_home = NULL;

	if( tel_home )	addPropValue( tel_home, "TYPE", "HOME" );

	if( mobile )	tel_cell = addPropValue(vcard,	VCTelephoneProp,	mobile );	/* TYPE:cell */
	else			tel_cell = NULL;

	if( tel_cell )	addPropValue( tel_cell, "TYPE", "CELL" );

	if( mail )		addPropValue(vcard,	VCEmailAddressProp,	mail ); /* TYPE:internet */
	if( etc )		addPropValue(vcard,	VCNoteProp,		etc );
	if( category )	addPropValue(vcard,	VCCategoriesProp,	category );
	return( vcard );
}

VObject* sgChangeVCard(
	VObject *old,
	char *name,
	char *ruby,
	char *address,
	char *tel,
	char *mobile,
	char *mail,
	char *etc,
	char *category
	)
{
	VObject *new;

    /* chiisai memory wo free() shite, segment tsukuruyori,
	** matomete free & alloc no houga iidesho?
	*/
	new = sgCreateVCard(
				name,
				ruby,
				address,
				tel,
				mobile,
				mail,
				etc,
				category
				);

	sgRemoveVCard( old );

	return( new );
}

void sgRemoveVCard( VObject *o )
{
	cleanVObject( o );
}


#include "../src/sgaddr.h"

extern int array_tail;
extern struct person_data *array[MAX_PERSONS];

extern int array_tail_cate;
extern char *c_array[MAX_CATEGORY];

void sgCopyData2VCard( struct person_data *data, VObject *vcard )
{
	sgChangeVCard(
			vcard,
			data->name,
			data->ruby,
			data->home,
			data->phone,
			data->mobile,
			data->email,
			data->etc,
			data->category
			);
}

static char *strtoupper( char *src )
{
	char *p = src;

	if( src == NULL ){
		return( NULL );
	}

	while( *p ){
		*p = (char)toupper( *p );
		p++;
	}

	return( src );
}

/*
** vcc.c ޤˤRFC2426Ȱ㤦äƤΤǶ줷ʶΥǥ󥰤ˤʤäƤ
** ϤV3.0ˤʤäƤ롣ϤV2.1ǤV3.0Ǥϣ
*/
void sgCopyVCard2Data( VObject *vcard, struct person_data *data )
{
	int i;
	char *tmp, *n, *attr_n, *attr_u;
	char *str;
	VObject *props;
	VObject *attr;
	VObjectIterator t, p;

	if( vcard == (VObject *)NULL ){
		return;
	}


	/* ¸ߤץѥƥʬͤ򥻥åȤƤ */
	initPropIterator( &t, vcard );

	while( moreIteration( &t ) ){

		/* ꥫɤΥץѥƥεФ */
		props = nextVObject( &t );
		n = (char *)vObjectName( props );

		/*---< FullName >---*/
		if( strcmp( n, VCFullNameProp ) == 0 ){
			tmp = (char *)vObjectUStringZValue( props );
			if( tmp ){
				if( !data->home ){
					data->name = fakeCString( (const wchar_t *)tmp );
				}
			}
			continue;
		}

		/*---< Ruby >---*/
		if( strcmp( n, VCSortStringProp ) == 0 ){
			tmp = (char *)vObjectUStringZValue( props );
			if( tmp ){
				if( !data->ruby ){
					data->ruby = fakeCString( (const wchar_t *)tmp );
				}
			}
			continue;
		}

		/*---< Home >---*/
		if( strcmp( n, VCAdrProp ) == 0 ){
			tmp = (char *)vObjectUStringZValue( props );
			if( tmp ){
				if( !data->home ){
					data->home = fakeCString( (const wchar_t *)tmp );
				}
				continue;
			}

			/*
			** vcc.cȤȡΤ"BOX"ץѥƥ°ͤ
			** ֹϺǽΥץѥƥͤΤˡäϰ㤦档
			*/
			initPropIterator( &p, props );

			while( moreIteration( &p ) ){
				attr = nextVObject( &p );
				attr_n = (char *)vObjectName( attr );
				attr_u = strdup(attr_n);

				tmp = (char *)vObjectUStringZValue( attr );
				if( tmp && !data->home ){
					data->home = fakeCString( (const wchar_t *)tmp );
				}
				
			}

			continue;
		}

		/*---< Telephone(Home,Cell) >---*/
		if( strcmp( n, VCTelephoneProp ) == 0 ){

			/*
			** ֹTYPE꤬äƤɬǽΥץѥƥͤ
			** ǡTYPE°Υץѥƥˤϥѥ󤬤äơ
			** TEL:03-1111-2222 ̤
			** TEL;HOME:03-1111-2222ȡid:HOMEΥץѥƥ̵Υ֥Ȥ
			** TEL;TYPE=HOME:03-1111-2222ȡid:TYPE :HOMEΥ֥Ȥ
			** TEL;TYPE=HOME,CELL:03-1111-2222ȡid:TYPE :HOME,CELLΥ֥Ȥ
			** TEL;TYPE=HOME;TYPE=CELL:03-1111-2222ȡid:TYPE :HOME,TYPEΥ֥Ȥ
			** ¿ʬǸϥХʤɡ
			*/
			initPropIterator( &p, props );

			tmp = (char *)vObjectUStringZValue( props );

			while( moreIteration( &p ) ){

				attr = nextVObject( &p );
				attr_n = (char *)vObjectName( attr );
				attr_u = strdup(attr_n);

				if( strcmp( strtoupper(attr_u), "TYPE" ) == 0 ){
					free( attr_u );
					attr_n = (char *)vObjectUStringZValue( attr );
					attr_u = strdup(attr_n);
					strtoupper(attr_u);
				}
				if( attr_u ){
					if( strstr( attr_u, "HOME" ) != NULL ){
						if( tmp ){
							if( !data->phone ){
								data->phone = fakeCString( (const wchar_t *)tmp );
							}
						}
					}
					if( strstr( attr_u, "CELL" ) != NULL ){
						if( tmp ){
							if( !data->mobile ){
								data->mobile = fakeCString( (const wchar_t *)tmp );
							}
						}
					}
				}
			}
			continue;
		}

		/*---< e-Mail >---*/
		if( strcmp( n, VCEmailAddressProp ) == 0 ){
			tmp = (char *)vObjectUStringZValue( props );
			if( tmp ){
				if( !data->email ){
					data->email = fakeCString( (const wchar_t *)tmp );
				}
			}
			continue;
		}

		/*---< Etc. >---*/
		if( strcmp( n, VCNoteProp ) == 0 ){
			tmp = (char *)vObjectUStringZValue( props );
			if( tmp ){
				if( !data->etc ){
					data->etc = fakeCString( (const wchar_t *)tmp );
				}
			}
			continue;
		}

		/*---< Category >---*/
		if( strcmp( n, VCCategoriesProp ) == 0 ){
			tmp = (char *)vObjectUStringZValue( props );
			if( tmp ){
				str = fakeCString( (const wchar_t *)tmp );
				for( i=0; i<array_tail_cate; i++ ){
					if( strcmp( c_array[i], str ) == 0 ){
						if( !data->category ){
							data->category = c_array[i];
						}
						break;
					}
				}
				free( str );
			}
			continue;
		}

	}

	if( !data->name )		data->name = strdup( "" );
	if( !data->ruby )		data->ruby = strdup( "" );
	if( !data->home )		data->home = strdup( "" );
	if( !data->phone )		data->phone = strdup( "" );
	if( !data->mobile )		data->mobile = strdup( "" );
	if( !data->email )		data->email = strdup( "" );
	if( !data->etc )		data->etc = strdup( "" );
	if( !data->category )	data->category = strdup( "" );

}


/*
** sgReadVCard()     0 < return_value  : ³Բǽʥ顼
**                   0 =                 ɤ߹
**                   0 >                 ³Բǽʥ顼
*/
int sgReadVCard()
{
	char *env;
	char fname[2048];
	VObject *vcard;
	FILE *fp;
	struct person_data *data;
	char c;
	int	is_blankfile_flag;
	int is_vcard_flag;
	char buff[32];

	env = getenv( "HOME" );
	if( env ){
		sprintf( fname, "%s/sgaddrbook.vcd", env );
	}else{
		sprintf( fname, "./sgaddrbook.vcd" );
	}

    fp = fopen( fname, "r" );
	if( fp == (FILE*)NULL ){
		perror( "VCard File Read" );
		return( 1 );
	}

	is_vcard_flag = 0;
	is_blankfile_flag = 1;
	while( 1 ){
		c = fgetc( fp );
		if( feof( fp ) ){
			break;
		}

		is_blankfile_flag = 0;
		if( strchr( " \t\n", c ) == NULL ){
			memset( buff, '\0', sizeof(buff) );
			ungetc( c, fp );
			fgets( buff, sizeof(buff)-1, fp );
			if( buff[strlen(buff)-1] == '\n' )
				buff[strlen(buff)-1] = '\0';

			strtoupper(buff);

			if( strcmp( buff, "BEGIN:VCARD" ) == 0 ){
				is_vcard_flag = 1;
			}

			break;
		}
	}

	/*
	** ǡ¸ߤơVCARDǤʤ票顼Ȥ
	*/
	if( is_blankfile_flag == 0
	&&  is_vcard_flag == 0 ){
		printf( "VCard File Format error\n" );
		return( -1 );
	}

    if( is_blankfile_flag ){
		fclose( fp );
		return( 0 );
	}


	rewind( fp );

	vcard = Parse_MIME_FromFile( fp );
	if( vcard == (VObject *)NULL ){
		perror( "VCard File Read" );
		return( -1 );
	}

	while( vcard ){

		data = create_person_data();
		if( data == (struct person_data *)NULL ){
			perror( "VCard File Read" );
			return( -2 );
		}

		sgCopyVCard2Data( vcard, data );

		insert_person_data( data );

		vcard = nextVObjectInList( vcard );
	}

	fclose( fp );

	return( 0 );

}

int sgWriteVCard()
{
	int i;
	char *env;
	char fname[2048];
	FILE *fp;

	env = getenv( "HOME" );
	if( env ){
		sprintf( fname, "%s/sgaddrbook.vcd", env );
	}else{
		sprintf( fname, "./sgaddrbook.vcd" );
	}

    fp = fopen( fname, "w" );
	if( fp == (FILE*)NULL ){
		perror( "VCard File Write" );
		return( -1 );
	}

	for( i=0; i<array_tail; i++ ){

		if( i>0 ){
			fprintf( fp, "\n" );
		}

		fprintf( fp, "BEGIN:VCARD\n" );

		if( array[i]->name )		fprintf( fp, "FN:%s\n",				array[i]->name );

		fprintf( fp, "N:%s\n",			"" );
		fprintf( fp, "VERSION:%s\n",	"3.0" );

		if( array[i]->ruby		&& strlen(array[i]->ruby) > 0 )
			fprintf( fp, "SORT-STRING:%s\n",		array[i]->ruby );

		if( array[i]->home		&& strlen(array[i]->home) > 0 )
			fprintf( fp, "ADR:%s\n",				array[i]->home );

		if( array[i]->phone		&& strlen(array[i]->phone) > 0 )
			fprintf( fp, "TEL;TYPE=HOME:%s\n",	array[i]->phone );

		if( array[i]->mobile	&& strlen(array[i]->mobile) > 0 )
			fprintf( fp, "TEL;TYPE=CELL:%s\n",	array[i]->mobile );

		if( array[i]->email		&& strlen(array[i]->email) > 0 )
			fprintf( fp, "EMAIL:%s\n",			array[i]->email );

		if( array[i]->etc		&& strlen(array[i]->etc) > 0 )
			fprintf( fp, "NOTE:%s\n", 			array[i]->etc );

		if( array[i]->category	&& strlen(array[i]->category) > 0 )
			fprintf( fp, "CATEGORIES:%s\n",	 	array[i]->category );


		fprintf( fp, "END:VCARD\n" );

	}

	fclose( fp );

	return( 0 );
}
